define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {
    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'article/article/index' + location.search,
                    add_url: 'article/article/add',
                    edit_url: 'article/article/edit',
                    del_url: 'article/article/del',
                    multi_url: 'article/article/multi',
                    import_url: 'article/article/import',
                    table: 'article',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'cid', title: __('Cid')},
                        {field: 'article_category_id', title: __('Article_category_id'), operate: 'LIKE'},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'author', title: __('Author'), operate: 'LIKE'},
                        {field: 'image', title: __('Image'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'visit', title: __('Visit')},
                        {field: 'url', title: __('Url'), operate: 'LIKE', formatter: Table.api.formatter.url},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'releasetime', title: __('Releasetime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'hide', title: __('Hide')},
                        {field: 'admin_id', title: __('Admin_id')},
                        {field: 'is_hotdata', title: __('Is_hotdata'), searchList: {"0":__('Is_hotdata 0'),"1":__('Is_hotdata 1')}, formatter: Table.api.formatter.normal},
                        {field: 'is_recdata', title: __('Is_recdata'), searchList: {"0":__('Is_recdata 0'),"1":__('Is_recdata 1')}, formatter: Table.api.formatter.normal},
                        {field: 'sort', title: __('Sort')},
                        {field: 'status', title: __('Status'), searchList: {"0":__('Status 0'),"1":__('Status 1')}, formatter: Table.api.formatter.status},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
           
            $("#c-article_category_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()},isTree:1};
            });
            Controller.api.bindevent();
        },
        edit: function () {

            $("#c-article_category_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()},isTree:1};
            });
            //   $("#c-article_category_id").attr("data-field","")
            //   $("#c-article_category_id").attr("data-field",attr)
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                console.log('修改')
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});