define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'article/article_category/index' + location.search,
                    add_url: 'article/article_category/add',
                    edit_url: 'article/article_category/edit',
                    del_url: 'article/article_category/del',
                    multi_url: 'article/article_category/multi',
                    import_url: 'article/article_category/import',
                    table: 'article_category',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'cid', title: __('Cid')},
                        {field: 'pid', title: __('Pid')},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'intr', title: __('Intr'), operate: 'LIKE'},
                        {field: 'image', title: __('Image'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'status', title: __('Status'), searchList: {"0":__('Status 0'),"1":__('Status 1')}, formatter: Table.api.formatter.status},
                        {field: 'sort', title: __('Sort')},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'hidden', title: __('Hidden'), searchList: {"0":__('Hidden 0'),"1":__('Hidden 1')}, formatter: Table.api.formatter.normal},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            $("#c-article_category_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()},isTree:1};
            });
            Controller.api.bindevent();
        },
        edit: function () {
             $("#c-article_category_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()},isTree:1};
            });
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});