define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'project/project_donation_info/index' + location.search,
                    add_url: 'project/project_donation_info/add',
                    edit_url: 'project/project_donation_info/edit',
                    del_url: 'project/project_donation_info/del',
                    multi_url: 'project/project_donation_info/multi',
                    import_url: 'project/project_donation_info/import',
                    table: 'project_donation_info',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'cid', title: __('Cid')},
                        {field: 'pro_id', title: __('Pro_id')},
                        {field: 'project_donation_id', title: __('Project_donation_id')},
                        {field: 'project_donation_num', title: __('Project_donation_num')},
                        {field: 'received', title: __('Received')},
                        {field: 'transport', title: __('Transport')},
                        {field: 'send_num', title: __('Send_num')},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            $("#c-pro_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()}};
            });
            Controller.api.bindevent();
        },
        edit: function () {
            $("#c-pro_id").data("params", function (obj) {
                return {custom: {cid: $("#c-cid").val()}};
            });
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});