define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'training/training/index' + location.search,
                    add_url: 'training/training/add',
                    edit_url: 'training/training/edit',
                    del_url: 'training/training/del',
                    multi_url: 'training/training/multi',
                    import_url: 'training/training/import',
                    table: 'training',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'cid', title: __('Cid')},
                        {field: 'title', title: __('Title'), operate: 'LIKE'},
                        {field: 'image', title: __('Image'), operate: false, events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'address', title: __('Address'), operate: 'LIKE'},
                        {field: 'latitude', title: __('Latitude'), operate: 'LIKE'},
                        {field: 'longitude', title: __('Longitude'), operate: 'LIKE'},
                        {field: 'tel', title: __('Tel'), operate: 'LIKE'},
                        {field: 'reg_start', title: __('Reg_start'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'reg_end', title: __('Reg_end'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'activity_start', title: __('Activity_start'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'activity_end', title: __('Activity_end'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'max_number', title: __('MaxNumber')},
                        {field: 'number', title: __('Number')},
                        {field: 'status', title: __('Status'), searchList: {"0":__('Status 0'),"1":__('Status 1'),"-1":__('Status -1')}, formatter: Table.api.formatter.status},
                        {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});